﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.Xml.Xsl;
using System.IO;


namespace XML_Read
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            XmlDocument xmldoc = new XmlDocument();
            XmlNode xmlnode;
            XmlElement xmlelem;

            //Add XML declaration
            //xmlnode = xmldoc.CreateNode ( XmlNodeType.XmlDeclaration , "" , "" ) ;
            xmlnode = xmldoc.CreateXmlDeclaration("1.0", "utf-8", null);
            xmldoc.AppendChild(xmlnode);
            //Add a root element
            xmlelem = xmldoc.CreateElement("", "Employees", "");
            xmldoc.AppendChild(xmlelem);
            //Add an other element
            for (int i = 1; i < 3; i++)
            {
                XmlNode root = xmldoc.SelectSingleNode("Employees");//selet "Employees" node
                XmlElement xe1 = xmldoc.CreateElement("Node" + i);//Add a "Node" to "Employees" node
                xe1.SetAttribute("genre", "Lee");//Set "genre" attribute to "Node"
                xe1.SetAttribute("ISBN", "2-3631-4");//Set "ISBN" attribute to "Node"

                XmlElement xesub1 = xmldoc.CreateElement("title");
                xesub1.InnerText = "Learning CS";//Set the content to "title" node
                xe1.AppendChild(xesub1);//Add "title: node to "Node"
                XmlElement xesub2 = xmldoc.CreateElement("author");
                xesub2.InnerText = "Hold";
                xe1.AppendChild(xesub2);
                XmlElement xesub3 = xmldoc.CreateElement("price");
                xesub3.InnerText = "58.3";
                xe1.AppendChild(xesub3);
                root.AppendChild(xe1);
            }
            // Save the document to a file and auto-indent the output.
            XmlTextWriter writer = new XmlTextWriter("\\temp\\data.xml", null);
            writer.Formatting = Formatting.Indented;
            xmldoc.Save(writer);            
        }

        private void button2_Click(object sender, EventArgs e)
        {

            string FileName = "\\temp\\data.xml";

            try
            {
                if (File.Exists(FileName))
                {
                    XmlDocument xmldoc = new XmlDocument();
                    xmldoc.Load(FileName);
                    //Selec a new node
                    XmlNode root = xmldoc.SelectSingleNode("Employees");
                    //Add a new element      
                    XmlElement xe1 = xmldoc.CreateElement("Node3");//Add a "Node2" to "Employees" node
                    xe1.SetAttribute("genre", "Tom");//Set "genre" attribute to "Node2"
                    xe1.SetAttribute("ISBN", "1-111-1");//Set "ISBN" attribute to "Node2"

                    XmlElement xesub1 = xmldoc.CreateElement("title");
                    xesub1.InnerText = "Forget X";//Set the content to "title" node
                    xe1.AppendChild(xesub1);//Add "title: node to "Node2"
                    XmlElement xesub2 = xmldoc.CreateElement("author");
                    xesub2.InnerText = "None";
                    xe1.AppendChild(xesub2);
                    XmlElement xesub3 = xmldoc.CreateElement("price");
                    xesub3.InnerText = "Free";
                    xe1.AppendChild(xesub3);

                    root.AppendChild(xe1);
                    xmldoc.Save(FileName);
                }
                else
                    Console.WriteLine(FileName + " doesn't exist");
            }

            catch (Exception objExp)
            {
                Console.WriteLine("Exception : " + objExp.Message);
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            string FileName = "\\temp\\data.xml";

            try
            {
                if (File.Exists(FileName))
                {
                    XmlDocument xmldoc = new XmlDocument();
                    xmldoc.Load(FileName);

                    XmlNodeList nodelist = xmldoc.SelectSingleNode("Employees").ChildNodes;
                    foreach (XmlNode node in nodelist)
                    {
                        XmlElement xmlelement = (XmlElement)node;

                        if (xmlelement.GetAttribute("genre") == "Tom")
                        {
                            //  xmlelement.RemoveAll();
                            xmldoc.SelectSingleNode("Employees").RemoveChild(node);
                            break;
                        }
                    }
                    xmldoc.Save(FileName);
                }
                else
                    Console.WriteLine(FileName + " doesn't exist");
            }


            catch (Exception objExp)
            {
                Console.WriteLine("Exception : " + objExp.Message);
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            string FileName = "\\temp\\data.xml";

            try
            {
                StreamReader sr = new StreamReader(FileName);

                while (sr.Peek() >= 0)
                {
                    Console.WriteLine(sr.ReadLine());
                }
            }
            catch (Exception objExp)
            {
                Console.WriteLine("Exception : " + objExp.Message);
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            string FileName = @"\temp\e.xml";
            try
            {
                if (File.Exists(FileName))
                {
                    XmlDocument docXML = new XmlDocument();
                    docXML.Load(@"\temp\e.xml");

                    XmlElement nodRoot = docXML.DocumentElement;

                    /*Query the nodes whose the tag name is "no", the tag name is case-sensitive*/
                    XmlNodeList nodItems = nodRoot.GetElementsByTagName("no");

                    Console.WriteLine("item count=" + nodItems.Count.ToString());
                    for (int i = 0; i < nodItems.Count; i++)
                        Console.WriteLine(nodItems[i].InnerXml);

                    /*Query the nodes whose the tag name is "Name, the tag name is case-sensitive*/
                    nodItems = nodRoot.GetElementsByTagName("Name");

                    Console.WriteLine("item count=" + nodItems.Count.ToString());
                    for (int i = 0; i < nodItems.Count; i++)
                        Console.WriteLine(nodItems[i].InnerXml);
                }
                else
                    Console.WriteLine(FileName + " doesn't exist");

            }
            catch (Exception objExp)
            {
                Console.WriteLine("Exception : " + objExp.Message);
            }
        }
    }
}